import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.DataInputStream;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SpringLayout;
import javax.swing.border.EmptyBorder;

import lejos.pc.comm.NXTComm;
import lejos.pc.comm.NXTCommFactory;
import lejos.pc.comm.NXTInfo;


public class Main extends JFrame implements Runnable{
	private DataInputStream dis;

	private JPanel contentPane;
	private JButton btnConnetti;
	private JTextArea textArea;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		SpringLayout sl_contentPane = new SpringLayout();
		contentPane.setLayout(sl_contentPane);
		
		btnConnetti = new JButton("Connetti");
		btnConnetti.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				attivaComunicazione();
				}
		});
		contentPane.add(btnConnetti);
		
		JScrollPane scrollPane = new JScrollPane();
		sl_contentPane.putConstraint(SpringLayout.NORTH, scrollPane, 0, SpringLayout.NORTH, btnConnetti);
		sl_contentPane.putConstraint(SpringLayout.WEST, scrollPane, 6, SpringLayout.EAST, btnConnetti);
		sl_contentPane.putConstraint(SpringLayout.SOUTH, scrollPane, 0, SpringLayout.SOUTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.EAST, scrollPane, 0, SpringLayout.EAST, contentPane);
		contentPane.add(scrollPane);
		
		textArea = new JTextArea();
		scrollPane.setViewportView(textArea);
	}
	public void attivaComunicazione() {
		try {
			NXTComm nxtComm = NXTCommFactory.createNXTComm(NXTCommFactory.BLUETOOTH);
			NXTInfo[] nxtInfo = nxtComm.search("NXT");
			if (nxtInfo.length > 0)
				if (nxtComm.open(nxtInfo[0])) {
					btnConnetti.setEnabled(false);
					btnConnetti.setText("Connesso");
					dis = new DataInputStream(nxtComm.getInputStream());
					
					Thread thread = new Thread(this);
					thread.setDaemon(true);
					thread.start();
				}
				else {
					System.out.println("nessun dispositivo trovato");
				}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this, "Impossibile stabilire la connesisone");
		}
	}
	@Override
	public void run() {
		boolean connected = true;
		while(connected) {
			try {
				
				double valore=dis.readDouble();
				textArea.append(valore+ "\n");
				if (valore>90) {
					JOptionPane.showMessageDialog(textArea,"fate silenzio");
						}
			
			} catch (IOException e) {
				connected=false;
			}
		}
	}
}

		
